unit u_generate25;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,u_generate27, syblistbox, Buttons;

type
  Tf_form25 = class(TForm)
    btn_help: TButton;
    btn_back: TButton;
    btn_next: TButton;
    btn_cancel: TButton;
    Image1: TImage;
    e_tablename: TEdit;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    l_allfields: TSybListBox;
    l_thefields: TListBox;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label2: TLabel;
    procedure btn_cancelClick(Sender: TObject);
    procedure btn_backClick(Sender: TObject);
    procedure btn_nextClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btn_helpClick(Sender: TObject);
    procedure l_allfieldsDblClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure l_thefieldsDblClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    action :smallint;
  end;

var
  f_form25: Tf_form25;

implementation

{$R *.DFM}

procedure Tf_form25.btn_cancelClick(Sender: TObject);
begin
  action:=3;
  close;
end;

procedure Tf_form25.btn_backClick(Sender: TObject);
begin
  action:=1;
  close;
end;

procedure Tf_form25.btn_nextClick(Sender: TObject);
begin
  if l_thefields.items.count=0 then
  begin
    showmessage('Select at least one column!');
    exit;
  end;
  action:=2;
  f_form27.l_primarykeys.items.assign(l_thefields.items);
  f_form27.showmodal;
  if f_form27.action=3 then
  begin
    action:=3;
    close;
  end
  else
  if f_form27.action=4 then
  begin
    action:=4;
    close;
  end;
end;

procedure Tf_form25.FormActivate(Sender: TObject);
begin
  if length(e_tablename.text) = 0 then
  begin
    showmessage('Table name is invalid !');
    close;
  end;
  l_allfields.sql:='select name from syscolumns where id=object_id("' + e_tablename.text + '") order by colid';
  l_allfields.sqlexec;
  l_thefields.clear;
end;

procedure Tf_form25.btn_helpClick(Sender: TObject);
begin
  action:=0;
end;

procedure Tf_form25.l_allfieldsDblClick(Sender: TObject);
var i :integer;
begin
  if l_allfields.itemindex >= 0 then
  begin
    for i:=0 to l_thefields.items.count-1 do
    begin
      if l_thefields.items[i]=l_allfields.items[l_allfields.itemindex] then
        exit;
    end;
    l_thefields.items.add(l_allfields.items[l_allfields.itemindex]);
  end;
end;

procedure Tf_form25.Button2Click(Sender: TObject);
var i :integer;
begin
  l_thefields.clear;
  for i:=0 to l_allfields.items.count-1 do
  begin
    l_thefields.items.add(l_allfields.items[i]);
  end;
end;

procedure Tf_form25.l_thefieldsDblClick(Sender: TObject);
begin
  l_thefields.items.delete(l_thefields.itemindex);
end;

procedure Tf_form25.Button3Click(Sender: TObject);
begin
  if l_thefields.itemindex >= 0 then
    l_thefields.items.delete(l_thefields.itemindex);
end;

procedure Tf_form25.Button4Click(Sender: TObject);
begin
  l_thefields.clear;
end;

procedure Tf_form25.BitBtn1Click(Sender: TObject);
var oldindx,newindx :integer;
begin
  if l_thefields.itemindex >0 then
  begin
    oldindx:=l_thefields.itemindex;
    newindx:=l_thefields.itemindex-1;
    l_thefields.items.exchange(oldindx,newindx);
    l_thefields.itemindex:=newindx;
  end;
end;

procedure Tf_form25.BitBtn2Click(Sender: TObject);
var oldindx,newindx :integer;
begin
  if l_thefields.itemindex <l_thefields.items.count-1 then
  begin
    oldindx:=l_thefields.itemindex;
    newindx:=l_thefields.itemindex+1;
    l_thefields.items.exchange(oldindx,newindx);
    l_thefields.itemindex:=newindx;
  end;

end;

end.
